// Generated by purs version 0.12.0

// | This module defines the environment comonad transformer, `EnvT`.
"use strict";
var Control_Comonad = require("../Control.Comonad/index.js");
var Control_Comonad_Trans_Class = require("../Control.Comonad.Trans.Class/index.js");
var Control_Extend = require("../Control.Extend/index.js");
var Control_Semigroupoid = require("../Control.Semigroupoid/index.js");
var Data_Foldable = require("../Data.Foldable/index.js");
var Data_Function = require("../Data.Function/index.js");
var Data_Functor = require("../Data.Functor/index.js");
var Data_Newtype = require("../Data.Newtype/index.js");
var Data_Traversable = require("../Data.Traversable/index.js");
var Data_Tuple = require("../Data.Tuple/index.js");
var Prelude = require("../Prelude/index.js");

// | The environment comonad transformer.
// |
// | This comonad transformer extends the context of a value in the base comonad with a _global environment_ of
// | type `e`.
// |
// | The `ComonadEnv` type class describes the operations supported by this comonad.
var EnvT = function (x) {
    return x;
};

// | Change the environment type in an `EnvT` context.
var withEnvT = function (f) {
    return function (v) {
        return EnvT(new Data_Tuple.Tuple(f(v.value0), v.value1));
    };
};

// | Unwrap a value in the `EnvT` comonad.
var runEnvT = function (v) {
    return v;
};
var newtypeEnvT = new Data_Newtype.Newtype(function (n) {
    return n;
}, EnvT);

// | Change the underlying comonad and data type in an `EnvT` context.
var mapEnvT = function (f) {
    return function (v) {
        return EnvT(new Data_Tuple.Tuple(v.value0, f(v.value1)));
    };
};
var functorEnvT = function (dictFunctor) {
    return new Data_Functor.Functor(function (f) {
        return function (v) {
            return EnvT(new Data_Tuple.Tuple(v.value0, Data_Functor.map(dictFunctor)(f)(v.value1)));
        };
    });
};
var foldableEnvT = function (dictFoldable) {
    return new Data_Foldable.Foldable(function (dictMonoid) {
        return function (fn) {
            return function (v) {
                return Data_Foldable.foldMap(dictFoldable)(dictMonoid)(fn)(v.value1);
            };
        };
    }, function (fn) {
        return function (a) {
            return function (v) {
                return Data_Foldable.foldl(dictFoldable)(fn)(a)(v.value1);
            };
        };
    }, function (fn) {
        return function (a) {
            return function (v) {
                return Data_Foldable.foldr(dictFoldable)(fn)(a)(v.value1);
            };
        };
    });
};
var traversableEnvT = function (dictTraversable) {
    return new Data_Traversable.Traversable(function () {
        return foldableEnvT(dictTraversable.Foldable1());
    }, function () {
        return functorEnvT(dictTraversable.Functor0());
    }, function (dictApplicative) {
        return function (v) {
            return Data_Functor.map((dictApplicative.Apply0()).Functor0())(Data_Functor.map(Data_Functor.functorFn)(EnvT)(Data_Tuple.Tuple.create(v.value0)))(Data_Traversable.sequence(dictTraversable)(dictApplicative)(v.value1));
        };
    }, function (dictApplicative) {
        return function (f) {
            return function (v) {
                return Data_Functor.map((dictApplicative.Apply0()).Functor0())(Data_Functor.map(Data_Functor.functorFn)(EnvT)(Data_Tuple.Tuple.create(v.value0)))(Data_Traversable.traverse(dictTraversable)(dictApplicative)(f)(v.value1));
            };
        };
    });
};
var extendEnvT = function (dictExtend) {
    return new Control_Extend.Extend(function () {
        return functorEnvT(dictExtend.Functor0());
    }, function (f) {
        return function (v) {
            return EnvT(new Data_Tuple.Tuple(v.value0, Data_Functor.map(dictExtend.Functor0())(f)(Control_Extend.extend(dictExtend)(function ($68) {
                return EnvT(Data_Tuple.Tuple.create(v.value0)($68));
            })(v.value1))));
        };
    });
};
var comonadTransEnvT = new Control_Comonad_Trans_Class.ComonadTrans(function (dictComonad) {
    return function (v) {
        return v.value1;
    };
});
var comonadEnvT = function (dictComonad) {
    return new Control_Comonad.Comonad(function () {
        return extendEnvT(dictComonad.Extend0());
    }, function (v) {
        return Control_Comonad.extract(dictComonad)(v.value1);
    });
};
module.exports = {
    EnvT: EnvT,
    runEnvT: runEnvT,
    withEnvT: withEnvT,
    mapEnvT: mapEnvT,
    newtypeEnvT: newtypeEnvT,
    functorEnvT: functorEnvT,
    extendEnvT: extendEnvT,
    comonadEnvT: comonadEnvT,
    comonadTransEnvT: comonadTransEnvT,
    foldableEnvT: foldableEnvT,
    traversableEnvT: traversableEnvT
};
