// Generated by purs version 0.12.0

// | This module defines the `ComonadTrans` type class of _comonad transformers_.
"use strict";
var Control_Comonad = require("../Control.Comonad/index.js");

// | The `ComonadTrans` type class represents _comonad transformers_.
// |
// | A comonad transformer is a type constructor of kind `(* -> *) -> * -> *`, which
// | takes a `Comonad` as its first argument, and returns another `Comonad`.
// |
// | This allows us to extend a comonad to provide additional context. By iterating this
// | process, we create comonad transformer _stacks_, which contain all of the contextual information
// | required for a particular computation.
// |
// | The laws state that `lower` is a `Comonad` morphism.
// |
// | Laws:
// |
// | - `extract (lower a) = extract a`
// | - `lower (extend w (f <<< lower)) = extend (lower w) f`
var ComonadTrans = function (lower) {
    this.lower = lower;
};
var lower = function (dict) {
    return dict.lower;
};
module.exports = {
    lower: lower,
    ComonadTrans: ComonadTrans
};
