// Generated by purs version 0.12.0

// | Provides operators for a DSL to construct `Json` values:
// |
// | ``` purescript
// | myJson
// |  = "key1" := value1
// |  ~> "key2" :=? value2
// | ~>? "key3" := value3
// |  ~> jsonEmptyOibject
// | ```
"use strict";
var Control_Semigroupoid = require("../Control.Semigroupoid/index.js");
var Data_Argonaut_Core = require("../Data.Argonaut.Core/index.js");
var Data_Argonaut_Encode_Class = require("../Data.Argonaut.Encode.Class/index.js");
var Data_Functor = require("../Data.Functor/index.js");
var Data_Maybe = require("../Data.Maybe/index.js");
var Data_Tuple = require("../Data.Tuple/index.js");
var Foreign_Object = require("../Foreign.Object/index.js");
var Prelude = require("../Prelude/index.js");

// | The named implementation of the `(~>)` operator.
var extend = function (dictEncodeJson) {
    return function (v) {
        return function ($11) {
            return Data_Argonaut_Core.caseJsonObject(Data_Argonaut_Core.jsonSingletonObject(v.value0)(v.value1))(function ($12) {
                return Data_Argonaut_Core.fromObject(Foreign_Object.insert(v.value0)(v.value1)($12));
            })(Data_Argonaut_Encode_Class.encodeJson(dictEncodeJson)($11));
        };
    };
};

// | The named implementation of the `(~>?)` operator.
var extendOptional = function (dictEncodeJson) {
    return function (v) {
        if (v instanceof Data_Maybe.Just) {
            return extend(dictEncodeJson)(v.value0);
        };
        if (v instanceof Data_Maybe.Nothing) {
            return Data_Argonaut_Encode_Class.encodeJson(dictEncodeJson);
        };
        throw new Error("Failed pattern match at Data.Argonaut.Encode.Combinators line 54, column 1 - line 54, column 83: " + [ v.constructor.name ]);
    };
};

// | The named implementation of the `(:=)` operator.
var assoc = function (dictEncodeJson) {
    return function (k) {
        return function ($13) {
            return Data_Tuple.Tuple.create(k)(Data_Argonaut_Encode_Class.encodeJson(dictEncodeJson)($13));
        };
    };
};

// | The named implementation of the `(:=?)` operator.
var assocOptional = function (dictEncodeJson) {
    return function (k) {
        return Data_Functor.map(Data_Maybe.functorMaybe)(function ($14) {
            return assoc(Data_Argonaut_Encode_Class.encodeJsonJson)(k)(Data_Argonaut_Encode_Class.encodeJson(dictEncodeJson)($14));
        });
    };
};
module.exports = {
    assoc: assoc,
    assocOptional: assocOptional,
    extend: extend,
    extendOptional: extendOptional
};
