// Generated by purs version 0.12.0

// | Partial helper functions for working with immutable arrays.
"use strict";
var Data_Array = require("../Data.Array/index.js");
var Data_Ring = require("../Data.Ring/index.js");
var Prelude = require("../Prelude/index.js");

// | Get all but the first element of a non-empty array.
// |
// | Running time: `O(n)`, where `n` is the length of the array.
var tail = function (dictPartial) {
    return function (xs) {
        return Data_Array.slice(1)(Data_Array.length(xs))(xs);
    };
};

// | Get the last element of a non-empty array.
// |
// | Running time: `O(1)`.
var last = function (dictPartial) {
    return function (xs) {
        return xs[Data_Array.length(xs) - 1 | 0];
    };
};

// | Get all but the last element of a non-empty array.
// |
// | Running time: `O(n)`, where `n` is the length of the array.
var init = function (dictPartial) {
    return function (xs) {
        return Data_Array.slice(0)(Data_Array.length(xs) - 1 | 0)(xs);
    };
};

// | Get the first element of a non-empty array.
// |
// | Running time: `O(1)`.
var head = function (dictPartial) {
    return function (xs) {
        return xs[0];
    };
};
module.exports = {
    head: head,
    tail: tail,
    last: last,
    init: init
};
